package com.steerinfo.dil.service.impl;

import com.steerinfo.dil.mapper.WmshOutboundResultMapper;
import com.steerinfo.dil.model.WmshOutboundResult;
import com.steerinfo.dil.service.IWmshOutboundResultService;
import com.steerinfo.dil.util.DataChange;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.math.BigDecimal;
import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * WmshOutboundResult服务实现：
 * @author generator
 * @version 1.0-SNAPSHORT 2021-10-10 03:14
 * 类描述
 * 修订历史：
 * 日期：2021-10-10
 * 作者：generator
 * 参考：
 * 描述：WmshOutboundResult服务实现
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@Service(value = "wmshOutboundResultService")
public class WmshOutboundResultServiceImpl implements IWmshOutboundResultService {

    @Autowired
    private WmshOutboundResultMapper wmshOutboundResultMapper;

    /**
     * 查询所有的出库实绩
     * @param map
     * @return
     */
    @Override
    public List<Map<String, Object>> getAllResult(Map<String, Object> map) {
        return wmshOutboundResultMapper.getAllResult(map);
    }

    /**
     * 新增出库实绩
     *  resultTonnage 出库物资吨位
     *  batchId 批次ID
     *  portId 港口ID
     *  isClean 是否清场
     * @param map
     * @return
     */
    @Override
    public int addResult(Map<String, Object> map) {
        WmshOutboundResult wmshOutboundResult = new WmshOutboundResult();
        //获取主键
        Integer id = wmshOutboundResultMapper.getResultId();
        wmshOutboundResult.setResultId(new BigDecimal(id));
        //生成出库编号
        StringBuilder sb = new StringBuilder("GCKD");
        sb.append(id < 10 ? "0000000" + id : id < 100 ? "000000" + id : id < 1000 ? "00000" + id : id < 10000 ?
                "0000" + id : id < 100000 ? "000" + id : id < 1000000 ? "00" + id : id < 10000000 ? "0" + id : id.toString());
        wmshOutboundResult.setResultNumber(sb.toString());
        //添加出库物资吨位、批次ID
        wmshOutboundResult.setResultTonnage(DataChange.dataToBigDecimal(map.get("resultTonnage")));
        wmshOutboundResult.setBatchId(DataChange.dataToBigDecimal(map.get("batchId")));
        //添加港口ID、是否清场、出库时间
        wmshOutboundResult.setHarborId(DataChange.dataToBigDecimal(map.get("portId")));
        wmshOutboundResult.setResultClearing((String)(map.get("isClean")));
        wmshOutboundResult.setInsertTime(new Date());
        int i = wmshOutboundResultMapper.insertSelective(wmshOutboundResult);
        return i;
    }
}
